const {Collection} = require('@iconify/json-tools');
const BlenderSVG = require('icon-blender/lib/blender-svg');
const { writeFileSync, existsSync, mkdirSync } = require('fs')

module.exports = () => {

	return {
		postcssPlugin: 'postcss-bootstrap-icons',

		AtRule: {
            icon: node => {
				const [ key, name ] = node.params.trim().split(/\s+/);
				let collection	= new Collection();
				collection.loadIconifyCollection(key);
				const data = collection.getIconData(name);
				const svg = new BlenderSVG(data);
				const markup = svg.getSVG();
				const prefix = './public'
				const dir = 'img/icons'
                const output = `${prefix}/${dir}`
                if(!existsSync(output)) mkdirSync(output, {recursive: true})
				const postfix = `${dir}/${key}-${name}.svg`
				const fn = `${prefix}/${postfix}`
				if(!existsSync(fn)) writeFileSync(fn, markup)
				node.replaceWith(`background-image: url(${postfix})`);
            }
		}
	}
}

module.exports.postcss = true

